#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    int dis_rootdir;
    int dis_filter;
    int dis_outfile;
    enum SorDataType { SORT_LEX, SORT_LENGTH };
    enum SorDataType SORTDATATYPE;
    const char *progpath;
    const char *progdir;

    void set_parameter_rootdir(char *rootdir,int dis_rootdir);
    void set_parameter_filter (char *filter ,int dis_filter );
    void set_parameter_outfile(char *outfile,int dis_outfile);
    void search_files(void);
    int set_nfiles(void);
    bool save_in_outfile(void);
    void set_parameter_progpath(const char *ppath);
    void set_parameter_progdir(const char *pdir);

    ~MainWindow();

private slots:
    void on_pushButton_search_clicked();

    void on_pushButton_deleterow_clicked();

    void on_pushButton_rootdir_clicked();

    void on_pushButton_outfile_clicked();

    void on_pushButton_saveexit_clicked();

    void on_actionSave_files_triggered();

    void on_actionConfiguration_triggered();

    void on_actionTutorial_triggered();

    void on_actionAbout_triggered();

    void on_actionAbout_QT_libs_triggered();

private:
    Ui::MainWindow *ui;
};

#endif // MAINWINDOW_H
