#include <pds/pdsdatafunc.h>
#include "mainwindow.h"
#include <QApplication>

// listfiles --rootdir "/di/rec/to/ry/" --filter "*.bmp" --outfile "/fi/le/na/me" --dis-rootdir --dis-filter --dis-outfile
int main(int argc, char *argv[])
{
    int ID;

    char *rootdir=NULL;
    char *filter=NULL;
    char *outfile=NULL;

    int  dis_rootdir=PDS_WRONG;
    int  dis_filter=PDS_WRONG;
    int  dis_outfile=PDS_WRONG;

    char *progpath=pds_get_absolute_programpath();
    char *progdir=pds_get_absolute_dirname();
    char *homedir=pds_get_homedir ();

    char *static_ptr=NULL;


    ///////////////////////////////////////////////////////////////////////////////
    /// HELP
    ///////////////////////////////////////////////////////////////////////////////
    ID=pds_exist_param (argc,argv,"--help");
    if(ID==PDS_OK)
    {
        char *filename=pds_sprintf ("%s%c%s%c%s%c%s%c%s%c%s.md",progdir,pds_filesep(),
                                                                "..",pds_filesep(),
                                                                "share",pds_filesep(),
                                                                "doc",pds_filesep(),
                                                                APP_TARGET,pds_filesep(),
                                                                APP_TARGET);
        char *tmp=pds_string_new_from_file (filename);
        if(tmp!=NULL)
        {
            printf("%s\n",tmp);
            return EXIT_SUCCESS;
        }
        else
        {
            fprintf(stderr,"\nProblems open the file:%s\n\n",filename);
            return EXIT_FAILURE;
        }
    }

    ///////////////////////////////////////////////////////////////////////////////
    /// Checking strings parameters
    ///////////////////////////////////////////////////////////////////////////////
    ID=pds_get_chars_param (argc,argv,"--rootdir",&static_ptr);
    if((ID==PDS_WRONG)||(strlen(static_ptr)<=0))
    {
        rootdir=strdup(homedir);
        dis_rootdir=PDS_WRONG;
    }
    else
    {
        rootdir=strdup(static_ptr);
        dis_rootdir=PDS_OK;
    }
    fprintf(stdout,"rootdir:\t%s\n",rootdir);

    ID=pds_get_chars_param (argc,argv,"--filter"  ,&static_ptr);
    if((ID==PDS_WRONG)||(strlen(static_ptr)<=0))
    {
        filter=strdup("*.bmp");
        dis_filter=PDS_WRONG;
    }
    else
    {
        filter=strdup(static_ptr);
        dis_filter=PDS_OK;
    }
    fprintf(stdout,"filter:\t%s\n",filter);

    ID=pds_get_chars_param (argc,argv,"--outfile" ,&static_ptr);
    if((ID==PDS_WRONG)||(strlen(static_ptr)<=0))
    {
        outfile=pds_sprintf("%s%clistfilesdat.listfiles",homedir,pds_filesep());
        dis_outfile=PDS_WRONG;
    }
    else
    {
        outfile=strdup(static_ptr);
        dis_outfile=PDS_OK;
    }
    fprintf(stdout,"outfile:\t%s\n",outfile);

    ///////////////////////////////////////////////////////////////////////////////
    /// Checking enable parameters
    ///////////////////////////////////////////////////////////////////////////////
    ID=pds_exist_param (argc,argv,"--dis-rootdir");
    if(ID==PDS_OK)  dis_rootdir=PDS_OK;
    ID=pds_exist_param (argc,argv,"--en-rootdir");
    if(ID==PDS_OK)  dis_rootdir=PDS_WRONG;

    ID=pds_exist_param (argc,argv,"--dis-filter");
    if(ID==PDS_OK)  dis_filter=PDS_OK;
    ID=pds_exist_param (argc,argv,"--en-filter");
    if(ID==PDS_OK)  dis_filter=PDS_WRONG;

    ID=pds_exist_param (argc,argv,"--dis-outfile");
    if(ID==PDS_OK)  dis_outfile=PDS_OK;
    ID=pds_exist_param (argc,argv,"--en-outfile");
    if(ID==PDS_OK)  dis_outfile=PDS_WRONG;


    ///////////////////////////////////////////////////////////////////////////////
    /// Begin program
    ///////////////////////////////////////////////////////////////////////////////



    QApplication a(argc, argv);
    MainWindow w;

    w.set_parameter_rootdir(rootdir,dis_rootdir);
    w.set_parameter_filter (filter ,dis_filter );
    w.set_parameter_outfile(outfile,dis_outfile);
    w.set_parameter_progpath(progpath);
    w.set_parameter_progdir(progdir);
    w.search_files();

    w.show();

    return a.exec();
}
