#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QGraphicsScene>

#include <pdsmm/pdsmm.h>

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    int NCLICKS;
    bool ONE_BY_ONE_CLICKED;
    bool GRID_C1_CLICKED;
    bool GRID_C2_CLICKED;

    QList<Pds::RegionRect> pointl_p0;

    QPen pen_point;
    QPen pen_corner;
    QColor color_point ;
    QColor color_corner;
    int IMAGEH;
    int IMAGEW;

    const char *progpath;
    const char *progdir;

    explicit MainWindow(QWidget *parent = 0);
    int dis_rootimage;
    int dis_outfile;


    void set_parameter_rootimage(char *rootimage,int dis_rootimage);
    void set_parameter_outfile(char *outfile,int dis_outfile);
    void set_parameter_progpath(const char *ppath);
    void set_parameter_progdir(const char *pdir);

    bool save_in_outfile(void);
    bool load_imagefile(QString  imagefile);


    bool load_regions(QString str);
    void clear_regions(void);
    bool plot_regionrect(Pds::RegionRect RR,QPen pencil);
    bool plot_point(QPoint pos,QPen pencil);
    QPoint remap_point(QPoint pos);

    void calcular_el_valor_de_nlin_ncol(int *nlin,int *ncol);
    ~MainWindow();



private slots:

    void my_mouse_event(QPoint &);



    void on_pushButton_imagefile_clicked();

    void on_pushButton_outfile_clicked();

    void on_pushButton_select_one_by_one_clicked();

    void on_pushButton_select_grid_clicked();

    void on_pushButton_grid_c1_clicked();

    void on_pushButton_grid_c2_clicked();

    void on_pushButton_saveexit_clicked();

    void on_pushButton_point_color_clicked();

    void on_pushButton_corner_color_clicked();

    void on_spinBox_grid_nvregions_valueChanged(int arg1);

    void on_spinBox_grid_nhregions_valueChanged(int arg1);

    void on_spinBox_grid_c1_line_valueChanged(int arg1);

    void on_spinBox_grid_c1_column_valueChanged(int arg1);

    void on_spinBox_grid_c2_line_valueChanged(int arg1);

    void on_spinBox_grid_c2_column_valueChanged(int arg1);



    void on_actionTutorial_triggered();

    void on_actionAbout_triggered();

    void on_actionAbout_QT_libs_triggered();

    void on_actionRemove_regions_triggered();

    void on_actionScreenshot_triggered();

    void on_actionLoad_regions_triggered();

    void on_actionSave_regions_triggered();


private:
    Ui::MainWindow *ui;
    QGraphicsScene *scene;
};

#endif // MAINWINDOW_H
