#include <pds/pdsdatafunc.h>
#include "mainwindow.h"
#include <QApplication>

int main(int argc, char *argv[])
{
    int ID;

    char *rootimage=NULL;
    char *outfile=NULL;

    int  dis_rootimage=PDS_WRONG;
    int  dis_outfile=PDS_WRONG;

    char *progpath=pds_get_absolute_programpath();
    char *progdir=pds_get_absolute_dirname();
    char *homedir=pds_get_homedir();

    char *static_ptr=NULL;


    ///////////////////////////////////////////////////////////////////////////////
    /// HELP
    ///////////////////////////////////////////////////////////////////////////////
    ID=pds_exist_param (argc,argv,"--help");
    if(ID==PDS_OK)
    {
        char *filename=pds_sprintf ("%s%c%s%c%s%c%s%c%s%c%s.md",progdir,pds_filesep(),
                                                                "..",pds_filesep(),
                                                                "share",pds_filesep(),
                                                                "doc",pds_filesep(),
                                                                APP_TARGET,pds_filesep(),
                                                                APP_TARGET);
        char *tmp=pds_string_new_from_file (filename);
        if(tmp!=NULL)
        {
            printf("%s\n",tmp);
            return EXIT_SUCCESS;
        }
        else
        {
            fprintf(stderr,"\nProblems open the file:%s\n\n",filename);
            return EXIT_FAILURE;
        }
    }

    ///////////////////////////////////////////////////////////////////////////////
    /// Checking strings parameters
    ///////////////////////////////////////////////////////////////////////////////
    ID=pds_get_chars_param (argc,argv,"--rootimage",&static_ptr);
    if((ID==PDS_WRONG)||(strlen(static_ptr)<=0))
    {
        rootimage=strdup("");
        dis_rootimage=PDS_WRONG;
    }
    else
    {
        rootimage=strdup(static_ptr);
        dis_rootimage=PDS_OK;
    }
    fprintf(stdout,"rootimage:\t%s\n",rootimage);

    ID=pds_get_chars_param (argc,argv,"--outfile" ,&static_ptr);
    if((ID==PDS_WRONG)||(strlen(static_ptr)<=0))
    {
        outfile=pds_sprintf("%s%clistregionsdat.listregions",homedir,pds_filesep());
        dis_outfile=PDS_WRONG;
    }
    else
    {
        outfile=strdup(static_ptr);
        dis_outfile=PDS_OK;
    }
    fprintf(stdout,"outfile:\t%s\n",outfile);


    ///////////////////////////////////////////////////////////////////////////////
    /// Checking enable parameters
    ///////////////////////////////////////////////////////////////////////////////
    ID=pds_exist_param (argc,argv,"--dis-rootimage");
    if(ID==PDS_OK)  dis_rootimage=PDS_OK;
    ID=pds_exist_param (argc,argv,"--en-rootimage");
    if(ID==PDS_OK)  dis_rootimage=PDS_WRONG;

    ID=pds_exist_param (argc,argv,"--dis-outfile");
    if(ID==PDS_OK)  dis_outfile=PDS_OK;
    ID=pds_exist_param (argc,argv,"--en-outfile");
    if(ID==PDS_OK)  dis_outfile=PDS_WRONG;

    ///////////////////////////////////////////////////////////////////////////////

    QApplication a(argc, argv);
    MainWindow w;

    w.set_parameter_rootimage(rootimage,dis_rootimage);
    w.set_parameter_outfile(outfile,dis_outfile);

    w.set_parameter_progpath(progpath);
    w.set_parameter_progdir(progdir);

    if(strlen(rootimage)!=0)
    w.load_regions(QString(outfile));

    w.show();

    return a.exec();
}
