#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QMessageBox>


bool MainWindow::save_in_outfile(void)
{
    QString outfile=ui->lineEdit_outfile->text();
    QByteArray ba_outfile = outfile.toLocal8Bit();

    if(outfile.length()==0)
    {
        QString msg(QString(tr("First you need select the output file. ")));
        QMessageBox Msgbox;
        Msgbox.critical(0,"[ERROR]",msg);

        ui->statusBar->showMessage(msg,5000);
        return false;
    }

    FILE *fd=fopen(ba_outfile.data(),"w");
    if(fd!=NULL)
    {
        Pds::RegionRect R;
        for(int i=0;i<this->pointl_p0.size();i++)
        {
            R=this->pointl_p0.at(i);
            fprintf(fd,"%d\t%d\t%d\t%d\n", R.l0(),R.c0(),R.nlin(),R.ncol());
        }
        fclose(fd);

        QString msg(QString(tr("[OK] Wrote ")+QString::number(this->pointl_p0.size())+tr(" regions in the file "))+outfile);
        QMessageBox Msgbox;
        Msgbox.setText(msg);
        Msgbox.exec();

        ui->statusBar->showMessage(msg,5000);

        return true;
    }
    else
    {
        QString msg(QString(tr("Error writing the file "))+outfile);
        QMessageBox Msgbox;
        Msgbox.critical(0,"[ERROR]",msg);
        //Msgbox.exec();

        ui->statusBar->showMessage(msg,5000);
        return false;
    }
}


bool MainWindow::load_imagefile(QString  imagefile)
{
    if(this->scene!=NULL)
        delete this->scene;

    this->scene=new QGraphicsScene(this);
    ui->graphicsView->setScene(this->scene);
    QPixmap pixmap;

    if(pixmap.load(imagefile))
    {
        this->scene->addPixmap(pixmap);

        this->IMAGEH=pixmap.height();
        this->IMAGEW=pixmap.width();
        this->scene->setSceneRect(0,0,IMAGEW,IMAGEH);

        if((ui->spinBox_grid_c2_line->value()==0)&&(ui->spinBox_grid_c1_line->value()==0))
            ui->spinBox_grid_c2_line->setValue(this->IMAGEH-1);
        if((ui->spinBox_grid_c2_column->value()==0)&&(ui->spinBox_grid_c1_column->value()==0))
            ui->spinBox_grid_c2_column->setValue(this->IMAGEW-1);

        ui->spinBox_grid_c1_line->setMaximum(this->IMAGEH-1);
        ui->spinBox_grid_c1_column->setMaximum(this->IMAGEW-1);

        ui->spinBox_grid_c2_line->setMaximum(this->IMAGEH-1);
        ui->spinBox_grid_c2_column->setMaximum(this->IMAGEW-1);
        //ui->graphicsView->fitInView(this->scene->sceneRect());
        return true;
    }
    else
    {
        this->IMAGEH=0;
        this->IMAGEW=0;
        return false;
    }
}
