#include "mainwindow.h"
#include "ui_mainwindow.h"



#include <QMessageBox>
//#include <QImageReader>
#include <QFileDialog>





void MainWindow::clear_regions()
{
    while (!pointl_p0.isEmpty())
        pointl_p0.removeFirst();
    ui->label_nregions->setText("0");

}

bool MainWindow::plot_regionrect(Pds::RegionRect RR,QPen pencil)
{
    QRect R(RR.c0(),RR.l0(),RR.ncol(),RR.nlin());
    this->scene->addRect(R,pencil);
    return true;
}
bool MainWindow::plot_point(QPoint pos,QPen pencil)
{
    this->scene->addEllipse(pos.x(),pos.y(),3,3,pencil);
    return true;
}

QPoint MainWindow::remap_point(QPoint pos)
{

    QPointF pf=ui->graphicsView->mapToScene(pos);
    //QPointF pf=ui->graphicsView->mapFromScene(pos);
    QPoint p(pf.x(),pf.y());

    return p;
}


bool MainWindow::load_regions(QString str)
{
    QString  origem;
    QString  inputfile;

    if(ui->lineEdit_imagefile->text().count()==0)
    {
        QString msg(QString(tr("First need be selected the imagefile.")));
        QMessageBox Msgbox;
        Msgbox.critical(0,"[ERROR]",msg);
    }
    else
    {
        if(str.length()==0)
        {
            if(ui->lineEdit_outfile->text().count()!=0)
                origem=QFileInfo(ui->lineEdit_outfile->text()).path();
            else
                origem=QDir::currentPath();

            inputfile = QFileDialog::getOpenFileName(this,
                                                     tr("Open Image File"),
                                                     origem,
                                                     tr("Data listregions file (*.listregions);;Data file (*.dat);;All files (*.*)"));
        }
        else inputfile=str;
    }

    if(inputfile.length()==0)
    {
        QString msg(QString(tr("No input file selected.")));
        QMessageBox Msgbox;
        Msgbox.critical(0,"[ERROR]",msg);
    }
    else
    {
        ui->statusBar->showMessage(QString(tr("Loading the file:"))+inputfile,4000);

        QFile ifile(inputfile);
        ifile.open(QIODevice::ReadOnly | QIODevice::Text);

        // read whole content
        QString content = ifile.readAll();
        //qInfo("content:<<"+content.toUtf8()+">>");
        // extract words
        QRegExp separator("\\s+");
        QStringList list = content.split(separator);

        ifile.close();

        int N=list.size();

        if(N<4)
        {
            QString msg(QString(tr("They were found "))+QString::number(N)+QString(tr(" elements in the input file (Minimum 4).")));
            QMessageBox Msgbox;
            Msgbox.critical(0,"[ERROR]",msg);
        }

        if( (N%4)!=0 )
        {
            N=(N/4)*4;
        }


        QPoint p;
        for(int i=0;i<N;i=i+4)
        {
            int l0=list.at(i).toInt();
            int c0=list.at(i+1).toInt();
            int nlin=list.at(i+2).toInt();
            int ncol=list.at(i+3).toInt();

            if( (c0<0)||(l0<0)||(c0>=IMAGEW)||(l0>=IMAGEH) )
            {
                QString msg(QString(tr("The init of region ("))+QString::number(l0)+QString(",")+QString::number(c0)+QString(tr(") and not be added.")));
                QMessageBox Msgbox;
                Msgbox.critical(0,"[ERROR]",msg);
            }
            else
            {
                if( ((c0+ncol-1)<0)||((l0+nlin-1)<0)||((c0+ncol-1)>=IMAGEW)||((l0+nlin-1)>=IMAGEH) )
                {
                    QString msg(QString(tr("The end of region ("))+QString::number(l0)+QString(",")+QString::number(c0)+QString(tr(") and not be added.")));
                    QMessageBox Msgbox;
                    Msgbox.critical(0,"[ERROR]",msg);
                }
                else
                {
                    Pds::RegionRect RR(l0,c0,nlin,ncol);
                    pointl_p0.append(RR);
                    ui->label_nregions->setText(QString::number(pointl_p0.size()));

                    plot_regionrect(RR,this->pen_point);
                }
            }
        }

    }
    return true;
}
